﻿Imports cc = Microsoft.VisualBasic.ControlChars
Imports System.Data.SqlClient

Imports Infragistics.Shared
Imports Infragistics.Win
Imports Infragistics.Win.UltraWinDataSource
Imports Infragistics.Win.UltraWinEditors
Imports Infragistics.Win.UltraWinGrid
Public Class Form1

#Region "Form Level Variables"

    Private IsFormInitialized As Boolean = False
    Private IsProcessing As Boolean = False
    Private CensusDataChanged As Boolean = False

    Friend UpdateSSCEDatabase As Boolean = False

    Private dtCensus, dtTypes, dtProducts As New DataTable
    Private dtWorkStatus As New DataTable

    Private copieSelectedRowCount As Integer = 0

#End Region

#Region "UltraDataSource1 Events"

    Private Sub UltraDataSource1_InitializeDataRow(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinDataSource.InitializeDataRowEventArgs) Handles UltraDataSource1.InitializeDataRow
        ' You can use the Tag off the row to store a piece of data that will
        ' make it easy to identify the row later on in CellDataRequested and
        ' other events.
        e.Row.Tag = dtCensus.Rows(e.Row.Index)
    End Sub
    Private Sub UltraDataSource1_CellDataRequested(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinDataSource.CellDataRequestedEventArgs) Handles UltraDataSource1.CellDataRequested

        ' We set the Tag of the row to a record object in InitializeDataRow.
        ' Here we can use that to get the associated Record object.

        Dim r As Object = CType(e.Row.Tag, Object)

        If e.Column.Key = "SubGroup" Then
            e.Data = (CType(r, DataRow))("SubGroup")
        ElseIf e.Column.Key = "Product" Then
            e.Data = (CType(r, DataRow))("Product")
        ElseIf e.Column.Key = "ContractTypeDescr" Then
            e.Data = (CType(r, DataRow))("ContractTypeDescr")
        ElseIf e.Column.Key = "Age" Then
            e.Data = (CType(r, DataRow))("Age")
        ElseIf e.Column.Key = "DateOfBirth" Then
            e.Data = (CType(r, DataRow))("DateOfBirth")
        ElseIf e.Column.Key = "Sex" Then
            e.Data = (CType(r, DataRow))("Sex")
        ElseIf e.Column.Key = "ZipCode" Then
            e.Data = (CType(r, DataRow))("ZipCode")
        ElseIf e.Column.Key = "Subscribers" Then
            e.Data = (CType(r, DataRow))("Subscribers")
        ElseIf e.Column.Key = "SubscriberType" Then
            e.Data = (CType(r, DataRow))("SubscriberType")
        End If

        ' Set CacheData to false to prevent UltraDataSource from caching the 
        ' data. Default value of CacheData property is true.
        e.CacheData = False

    End Sub
    Private Sub UltraDataSource1_CellDataUpdating(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinDataSource.CellDataUpdatingEventArgs) Handles UltraDataSource1.CellDataUpdating

        Dim r As DataRow = dtCensus.Rows(e.Row.Index)

        Dim cell As UltraGridCell = UltraGrid1.ActiveCell
        Dim row As UltraGridRow = UltraGrid1.ActiveRow

        If e.Column.Key = "SubGroup" Then
            If e.NewValue Is Nothing OrElse DBNull.Value Is e.NewValue OrElse e.NewValue = String.Empty Then
                r("SubGroup") = "1"
            Else
                r("SubGroup") = DirectCast(e.NewValue, String)
            End If
        ElseIf e.Column.Key = "Product" Then
            If e.NewValue Is Nothing OrElse DBNull.Value Is e.NewValue OrElse e.NewValue = String.Empty Then
                r("Product") = DBNull.Value
            Else
                r("Product") = DirectCast(e.NewValue, String)
            End If
        ElseIf e.Column.Key = "ContractTypeDescr" Then
            ' Value could be DBNull.
            If e.NewValue Is Nothing OrElse e.NewValue Is DBNull.Value Then
                'Null value
                r("ContractTypeDescr") = DBNull.Value
            Else
                ' Otherwise it will be the same type as the column's data type.
                r("ContractTypeDescr") = DirectCast(e.NewValue, String)
            End If
        ElseIf e.Column.Key = "Age" Then
            If e.NewValue Is Nothing OrElse DBNull.Value Is e.NewValue OrElse _
               IsNumeric(e.NewValue) = False OrElse e.NewValue < 0 Then
                r("Age") = 0
            Else
                r("Age") = DirectCast(IIf(e.NewValue > 100, 100, e.NewValue), Integer)
            End If
        ElseIf e.Column.Key = "DateOfBirth" Then
            If e.NewValue Is Nothing OrElse DBNull.Value Is e.NewValue OrElse _
               IsDate(e.NewValue) = False OrElse DirectCast(e.NewValue, Date).Year < 1900 Then
                r("DateOfBirth") = DBNull.Value
                If row.Cells("Age").Value Is Nothing Then
                    r("Age") = 0
                    row.Cells("Age").Value = 0
                End If
            Else
                r("DateOfBirth") = DirectCast(e.NewValue, Date)
                'Calculate the age
                Dim Age As Integer = CalculateAge(DirectCast(e.NewValue, Date))
                r("Age") = Age
                row.Cells("Age").Value = Age
            End If
        ElseIf e.Column.Key = "Sex" Then
            ' Value could be DBNull.
            If e.NewValue Is Nothing OrElse e.NewValue Is DBNull.Value Then
                'Null value
                r("Sex") = DBNull.Value
            ElseIf e.NewValue.ToString.ToUpper <> "M" AndAlso e.NewValue.ToString.ToUpper <> "F" Then
                'Invalid entry -- don't update it!
            Else
                ' Otherwise it will be the same type as the column's data type.
                r("Sex") = DirectCast(e.NewValue, String).ToUpper
            End If
        ElseIf e.Column.Key = "ZipCode" Then
            ' Value could be DBNull.
            If e.NewValue Is Nothing OrElse e.NewValue Is DBNull.Value Then
                'Null value
                r("ZipCode") = DBNull.Value
            ElseIf IsNumeric(e.NewValue) = False OrElse e.NewValue.ToString.Length <> 5 Then
                'Invalid entry -- don't update it!
            Else
                ' Otherwise it will be the same type as the column's data type.
                r("ZipCode") = DirectCast(e.NewValue, String)
            End If
        ElseIf e.Column.Key = "Subscribers" Then
            If e.NewValue Is Nothing OrElse e.NewValue Is DBNull.Value OrElse _
               IsNumeric(e.NewValue) = False OrElse e.NewValue <= 0 Then
                r("Subscribers") = 1
            Else
                r("Subscribers") = DirectCast(e.NewValue, Integer)
            End If
        ElseIf e.Column.Key = "SubscriberType" Then
            ' Value could be DBNull.
            If e.NewValue Is Nothing OrElse e.NewValue Is DBNull.Value Then
                'Null value
                r("SubscriberType") = DBNull.Value
            Else
                ' Otherwise it will be the same type as the column's data type.
                r("SubscriberType") = DirectCast(e.NewValue, String)
            End If
        End If

        ' Set CacheData to false so the UltraDataSource itself doesn't cache
        ' the value.
        e.CacheData = False

    End Sub
    Private Sub UltraDataSource1_RowAdding(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinDataSource.RowAddingEventArgs) Handles UltraDataSource1.RowAdding
        ' RowAdding is fired when a bound control tries to add a new row. Here
        ' you add the row to the external data structure. Index property off
        ' the event args indicates the location where the new row will be added
        ' in UltraDataSource' row collection. You can set that to a different value.
        ' By default it's the end of the row collection.
        dtCensus.Rows.Add(New Object() {DBNull.Value, DBNull.Value, DBNull.Value, 0, DBNull.Value, DBNull.Value, DBNull.Value, 1, DBNull.Value})
    End Sub
    Private Sub UltraDataSource1_RowDeleting(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinDataSource.RowDeletingEventArgs) Handles UltraDataSource1.RowDeleting
        ' RowDeleting is fired when a bound control tries to delete a row. Here
        ' you delete the associated row from the external data structure.
        dtCensus.Rows.RemoveAt(e.Row.Index)
    End Sub
    Private Sub UltraDataSource1_RowBeginEdit(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinDataSource.RowBeginEditEventArgs) Handles UltraDataSource1.RowBeginEdit
        ' In RowBeginEdit you backup the row data somewhere so when RowCancelEdit
        ' is fired as a result of user canceling row modifications, the row data 
        ' can be reverted back to the original values.
        Dim r As DataRow = CType(e.Row.Tag, DataRow)
    End Sub
    Private Sub UltraDataSource1_RowCancelEdit(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinDataSource.RowCancelEditEventArgs) Handles UltraDataSource1.RowCancelEdit
        ' Here you restore the original row data that you backed up in the 
        ' RowBeginEdit event handler.
        Dim r As DataRow = CType(e.Row.Tag, DataRow)
    End Sub
    Private Sub UltraDataSource1_RowEndEdit(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinDataSource.RowEndEditEventArgs) Handles UltraDataSource1.RowEndEdit
        ' RowEndEdit is fired when the control commits row modifications.
        ' Here you simply clear the backed up data.
        Dim r As DataRow = CType(e.Row.Tag, DataRow)
    End Sub
#End Region

#Region "Custom Procedures/Functions"

    Private Function CalculateAge(ByVal birthdate As DateTime) As Integer

        'Get the difference in years
        Dim years As Integer = DateTime.Now.Year - birthdate.Year

        'Subtract another year if we're before the  birth day in the current year
        If (DateTime.Now.Month < birthdate.Month) OrElse (DateTime.Now.Month = birthdate.Month AndAlso DateTime.Now.Day < birthdate.Day) Then
            years -= 1
        End If

        CalculateAge = IIf(years < 0, 0, years)

    End Function
    ''' <summary>
    ''' This procedure formats the DataGridView control on this form.
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub FormatDataGridView()

        ''''''''''''''''''''''''''''''''''''''''''''''
        ''  Setup the Contract Types DataGridView   ''
        ''''''''''''''''''''''''''''''''''''''''''''''
        With dgContractTypes

            'This grid is read-only!
            .ReadOnly = True

            .BackColor = Color.GhostWhite
            .BackgroundColor = Color.Lavender
            .BorderStyle = BorderStyle.Fixed3D

            .Font = New Font("Verdana", 8.0!)

            .AllowUserToOrderColumns = False
            .AllowUserToDeleteRows = False
            .AllowUserToAddRows = False

            ' Render alternating rows with a different background color
            .AlternatingRowsDefaultCellStyle.BackColor = Color.LightBlue

            ' Only one selection is supported at a time
            .MultiSelect = False

            'I'll create the columns myself!
            .AutoGenerateColumns = False

            ' Configure the grid to use cell selection
            .SelectionMode = DataGridViewSelectionMode.CellSelect

        End With

        '''''''''''''''''''''''''
        ''  Define the columns ''
        ''  (Contract Types)   ''
        '''''''''''''''''''''''''
        Dim ContractTier As New DataGridViewTextBoxColumn()
        ContractTier.DataPropertyName = "TierType"
        ContractTier.AutoSizeMode = DataGridViewAutoSizeColumnMode.None
        ContractTier.HeaderText = "Tier"
        ContractTier.Name = "TierType"
        ContractTier.Width = 50
        ContractTier.ReadOnly = True
        ContractTier.Visible = False
        ContractTier.DefaultCellStyle.Alignment = DataGridViewContentAlignment.TopLeft
        dgContractTypes.Columns.Add(ContractTier)

        Dim ContractTierNumber As New DataGridViewTextBoxColumn()
        ContractTierNumber.DataPropertyName = "TierNumber"
        ContractTierNumber.AutoSizeMode = DataGridViewAutoSizeColumnMode.None
        ContractTierNumber.HeaderText = "Code"
        ContractTierNumber.Name = "TierNumber"
        ContractTierNumber.Width = 50
        ContractTierNumber.ReadOnly = True
        ContractTierNumber.Visible = True
        ContractTierNumber.DefaultCellStyle.Alignment = DataGridViewContentAlignment.TopRight
        dgContractTypes.Columns.Add(ContractTierNumber)

        Dim ContractType As New DataGridViewTextBoxColumn()
        ContractType.DataPropertyName = "ContractType"
        ContractType.AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill
        ContractType.HeaderText = "Description"
        ContractType.Name = "ContractType"
        ContractType.Width = 100
        ContractType.ReadOnly = True
        ContractType.Visible = True
        ContractType.DefaultCellStyle.Alignment = DataGridViewContentAlignment.TopLeft
        dgContractTypes.Columns.Add(ContractType)

        Dim dvContractTypes As New DataView(dtTypes)
        dvContractTypes.RowFilter = "Tier = '" & cboTierType.SelectedItem & "'"
        dvContractTypes.Sort = "TierNumber"

        dgContractTypes.DataSource = dvContractTypes


    End Sub
    Private Sub BuildDataTables()

        dtCensus = New DataTable

        With dtCensus

            'Add the columns
            .Columns.Add("SubGroup", GetType(System.String))
            .Columns.Add("Product", GetType(System.String))
            .Columns.Add("ContractTypeDescr", GetType(System.String))
            .Columns.Add("Age", GetType(System.Int32))
            .Columns.Add("DateOfBirth", GetType(System.DateTime))
            .Columns.Add("Sex", GetType(System.String))
            .Columns.Add("ZipCode", GetType(System.String))
            .Columns.Add("Subscribers", GetType(System.Int32))
            .Columns.Add("SubscriberType", GetType(System.String))

            'Add the data
            .Rows.Add(New Object() {1, "PPO", "EEOnly", 10, DBNull.Value, "M", "64086", 1, "Active"})
            .Rows.Add(New Object() {1, "PPO", "EEFamily", 37, DBNull.Value, "F", "64086", 1, "Active"})
            .Rows.Add(New Object() {1, "HMO", "EESpOnly", 56, DBNull.Value, "F", "64086", 1, "Active"})
            .Rows.Add(New Object() {1, "POS", "EEOnly", 41, DBNull.Value, "M", "64063", 1, "Active"})
            .Rows.Add(New Object() {1, "PPO", "EEChren", 19, DBNull.Value, "F", "64063", 1, "Active"})
            .Rows.Add(New Object() {1, "PPO Select", "EEChren", 100, DBNull.Value, "F", "64063", 1, "Active"})
            .Rows.Add(New Object() {1, "HMO", "EEFamily", 66, DBNull.Value, "M", "64063", 1, "Active"})
            .Rows.Add(New Object() {1, "PPO", "EESpOnly", 32, DBNull.Value, "F", "64086", 1, "Active"})
            .Rows.Add(New Object() {1, "PPO", "EEOnly", 29, DBNull.Value, "F", "64086", 1, "Active"})
            .Rows.Add(New Object() {1, "HMO", "EEChren", 12, DBNull.Value, "M", "64086", 1, "Active"})

            'This will setup handlers to kick in the error color coding on the grid.
            'AddHandler dtCensus.ColumnChanging, New DataColumnChangeEventHandler(AddressOf Me.OnTableCellValueChanging)
            'AddHandler dtCensus.RowChanging, New DataRowChangeEventHandler(AddressOf Me.OnTableRowChanging)

        End With

        With dtProducts
            .Columns.Add("Product", GetType(System.String))
            .Rows.Add(New Object() {"HMO"})
            .Rows.Add(New Object() {"POS"})
            .Rows.Add(New Object() {"PPO"})
            .Rows.Add(New Object() {"PPO Select"})

        End With

        With dtWorkStatus
            .Columns.Add("WorkStatus", GetType(System.String))
            .Rows.Add(New Object() {"Active"})
            .Rows.Add(New Object() {"Cobra"})
            .Rows.Add(New Object() {"Hourly - Active"})
            .Rows.Add(New Object() {"Hourly - Cobra"})
            .Rows.Add(New Object() {"Hourly - Retiree <65"})
            .Rows.Add(New Object() {"Hourly - Retiree 65+"})
            .Rows.Add(New Object() {"Medicare Primary"})
            .Rows.Add(New Object() {"Retiree <65"})
            .Rows.Add(New Object() {"Retiree 65+"})
            .Rows.Add(New Object() {"Salary - Active"})
            .Rows.Add(New Object() {"Salary - Cobra"})
            .Rows.Add(New Object() {"Salary - Retiree <65"})
            .Rows.Add(New Object() {"Salary - Retiree 65+"})
            .Rows.Add(New Object() {"Waived"})
        End With

        With dtTypes

            .Columns.Add("Tier", GetType(System.String))
            .Columns.Add("TierNumber", GetType(System.Int16))
            .Columns.Add("ContractType", GetType(System.String))

            .Rows.Add(New Object() {"2T", 1, "EEOnly"})
            .Rows.Add(New Object() {"2T", 2, "EEFamily"})

            .Rows.Add(New Object() {"3T", 1, "EEOnly"})
            .Rows.Add(New Object() {"3T", 2, "EEPDep"})
            .Rows.Add(New Object() {"3T", 3, "EEFamily"})

            .Rows.Add(New Object() {"4T", 1, "EEOnly"})
            .Rows.Add(New Object() {"4T", 2, "EESpOnly"})
            .Rows.Add(New Object() {"4T", 3, "EEChren"})
            .Rows.Add(New Object() {"4T", 4, "EEFamily"})

            .Rows.Add(New Object() {"5T", 1, "EEOnly"})
            .Rows.Add(New Object() {"5T", 2, "EESpOnly"})
            .Rows.Add(New Object() {"5T", 3, "EECH1"})
            .Rows.Add(New Object() {"5T", 4, "EEChren"})
            .Rows.Add(New Object() {"5T", 5, "EEFamily"})
        End With

    End Sub
    ''' <summary>
    ''' This procedure sets up the UltraDataSource control which
    ''' is the link between the DataTable and the UltraGrid.
    ''' </summary>
    ''' <remarks></remarks>
    Private Sub SetupDataSource()

        '''''''''''''''''''''''''
        ''  Setup the columns  ''
        '''''''''''''''''''''''''
        With UltraDataSource1.Band
            .Columns.Add("SubGroup", GetType(String))
            .Columns.Add("Product", GetType(String))
            .Columns.Add("ContractTypeDescr", GetType(String))
            .Columns.Add("Age", GetType(Integer))
            .Columns.Add("DateOfBirth", GetType(Date))
            .Columns.Add("Sex", GetType(String))
            .Columns.Add("ZipCode", GetType(String))
            .Columns.Add("Subscribers", GetType(Integer))
            .Columns.Add("SubscriberType", GetType(String))
        End With

        '''''''''''''''''''''''''''''''''''''''''''''''''''
        ''  Load the DataTable into the UltraDataSource  ''
        ''  This control is used for processing large    ''
        ''  amounts of data.                             ''
        '''''''''''''''''''''''''''''''''''''''''''''''''''
        Dim item As DataRow
        For Each item In dtCensus.Rows
            UltraDataSource1.Rows.Add(item.ItemArray)
        Next

        Me.UltraGrid1.DisplayLayout.LoadStyle = LoadStyle.LoadOnDemand
        Me.UltraGrid1.DataSource = Me.UltraDataSource1
        'Me.UltraGrid1.SetDataBinding(Me.UltraDataSource1, "")

        ' Miscellaneous settings on UltraGrid.
        Me.UltraGrid1.DisplayLayout.ScrollStyle = ScrollStyle.Immediate

    End Sub

#End Region

#Region "UltraGrid1 Events"
    ''' <summary>
    ''' Initialize the UltraGrid component.
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub UltraGrid1_InitializeLayout(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs) Handles UltraGrid1.InitializeLayout

        'Set the update mode
        UltraGrid1.UpdateMode = UpdateMode.OnRowChangeOrLostFocus

        With e.Layout

            ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
            ''  Turn on all of the Cut, Copy, and Paste functionality.  ''
            ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
            .Override.AllowMultiCellOperations = AllowMultiCellOperation.All
            .Override.RowSelectors = DefaultableBoolean.True
            .Override.AllowUpdate = DefaultableBoolean.True
            .Override.SelectTypeCell = SelectType.ExtendedAutoDrag
            .Override.SelectTypeRow = SelectType.ExtendedAutoDrag

            ' Enable support for displaying errors through IDataErrorInfo interface. By default
            ' the functionality is disabled.
            .Override.SupportDataErrorInfo = SupportDataErrorInfo.RowsAndCells

            ' Set data error related appearances.
            .Override.DataErrorCellAppearance.ForeColor = Color.Red
            .Override.DataErrorRowAppearance.BackColor = Color.LightYellow
            .Override.DataErrorRowSelectorAppearance.BackColor = Color.Green

            ' Make the row selectors bigger so they can accomodate the data error icon as 
            ' well active row indicator.
            .Override.RowSelectorWidth = 32

            'Show two (2) Group/Column header lines
            .Bands(0).GroupHeaderLines = 2
            .Bands(0).ColHeaderLines = 2


            'Show the Add button at the bottom of the grid
            .Bands(0).AddButtonCaption = "&ADD"
            .Bands(0).AddButtonToolTipText = "Add a new census row"

            '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
            ''  In order to cut or copy, the user needs to select cells or rows.     ''
            ''  So set CellClickAction so that clicking on a cell selects that cell  ''
            ''  instead of going into edit mode.                                     ''
            '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
            .Override.CellClickAction = CellClickAction.CellSelect

            'allow the row to be sizable along the bottom row border and the record selectors
            '.Override.RowSizingArea = RowSizingArea.EntireRow

            ' Attach the UltradropDown to the ContractTypeDescr to column so that it displays
            ' numbers instead of names.

            .Bands(0).Columns("ContractTypeDescr").ValueList = Me.uddContractType
            .Bands(0).Columns("ContractTypeDescr").Style = ColumnStyle.DropDownValidate

            .Bands(0).Columns("Product").ValueList = Me.uddProducts
            .Bands(0).Columns("Product").Style = ColumnStyle.DropDownValidate

            .Bands(0).Columns("SubscriberType").ValueList = Me.uddWorkStatus
            .Bands(0).Columns("SubscriberType").Style = ColumnStyle.DropDownValidate

            ' Show add row.
            .Override.AllowAddNew = AllowAddNew.TemplateOnBottom

            ' ScrollBounds of ScrollToFill will prevent the user from scrolling the
            ' grid further down once the last row becomes fully visible.
            .ScrollBounds = ScrollBounds.ScrollToFill

            'Show the add button at the bottom of the grid
            .AddNewBox.Hidden = False
            .AddNewBox.Prompt = "Add new row"

            'Set individual column properties 
            .Bands(0).Columns("ZipCode").EditorControl = txtZipCode

            'Set individual column headings/alignments (required fields in BOLD)
            .Bands(0).Columns("Product").Header.Appearance.FontData.Bold = DefaultableBoolean.True

            .Bands(0).Columns("ZipCode").Header.Caption = "Zip Code"
            .Bands(0).Columns("ZipCode").Header.Appearance.FontData.Bold = DefaultableBoolean.True

            .Bands(0).Columns("Age").Header.Appearance.TextHAlign = HAlign.Center

            .Bands(0).Columns("DateOfBirth").Header.Caption = "Date of Birth"

            .Bands(0).Columns("Sex").MaxLength = 1
            .Bands(0).Columns("Sex").Header.Caption = "Gender"
            .Bands(0).Columns("Sex").Header.Appearance.FontData.Bold = DefaultableBoolean.True

            .Bands(0).Columns("ContractTypeDescr").Header.Caption = "Contract" & cc.NewLine & "Type"
            .Bands(0).Columns("ContractTypeDescr").Header.Appearance.FontData.Bold = DefaultableBoolean.True

            .Bands(0).Columns("Subscribers").Header.Appearance.FontData.Bold = DefaultableBoolean.True

            .Bands(0).Columns("SubscriberType").Header.Caption = "Work Status"

            'Set individual column width overrides
            .Bands(0).Columns("Product").Width = 70
            .Bands(0).Columns("ContractTypeDescr").Width = 70
            .Bands(0).Columns("Sex").Width = 60
            .Bands(0).Columns("ZipCode").Width = 70
            .Bands(0).Columns("SubscriberType").Width = 150

            '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
            ''  Set the CellActivation off the column something other than AllowEdit to prevent  ''
            ''  the user from modifying cells in that column. ActivateOnly allows the user to    ''
            ''  go into edit mode so the user can select and copy text, however the cell will    ''
            ''  be read-only thus preventing any data modification.                              ''
            '''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
            .Bands(0).Columns("DateOfBirth").Hidden = False
            .Bands(0).Columns("DateOfBirth").CellActivation = Activation.ActivateOnly

            ''''''''''''''''''''''''''''''''''''''''''''''''
            ''  These are the appearances we will add to  ''
            ''  control color coding on the UltraGrid.    ''
            ''''''''''''''''''''''''''''''''''''''''''''''''
            .Appearances.Add("LeftAlign")
            With .Appearances("LeftAlign")
                .TextHAlign = Infragistics.Win.HAlign.Left
            End With

            .Appearances.Add("CenterAlign")
            With .Appearances("CenterAlign")
                .TextHAlign = Infragistics.Win.HAlign.Center
            End With

            .Appearances.Add("RightAlign")
            With .Appearances("RightAlign")
                .TextHAlign = Infragistics.Win.HAlign.Right
            End With

            .Appearances.Add("MaxAge")
            With .Appearances("MaxAge")
                .ForeColor = Color.Red
                .BackColor = Color.LightPink
                .FontData.Bold = DefaultableBoolean.True
                .TextHAlign = Infragistics.Win.HAlign.Right
            End With

            .Appearances.Add("ZeroValue")
            With .Appearances("ZeroValue")
                .ForeColor = Color.Black
                .BackColor = Color.LightYellow
                .TextHAlign = Infragistics.Win.HAlign.Right
            End With

            .Appearances.Add("EmptyCell")
            With .Appearances("EmptyCell")
                .ForeColor = Color.Black
                .BackColor = Color.LightYellow
                .TextHAlign = Infragistics.Win.HAlign.Left
            End With

        End With


        'Hide the "Group By" box
        UltraGrid1.DisplayLayout.GroupByBox.Hidden = True


    End Sub
    ''' <summary>
    ''' This event is fired each time a row in the UltraGrid 
    ''' is initialized.  We will use this for color formatting.
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub UltraGrid1_InitializeRow(ByVal sender As Object, ByVal e As Infragistics.Win.UltraWinGrid.InitializeRowEventArgs) Handles UltraGrid1.InitializeRow

        If UltraGrid1.Rows.Count = 0 Then
            Stop
            Exit Sub
        End If

        Dim aCell As UltraGridCell

        For Each aCell In e.Row.Cells
            Select Case aCell.Column.Key
                Case "Product", "SubscriberType"
                    If aCell.Value.ToString = DBNull.Value.ToString OrElse aCell.Value.ToString = String.Empty Then
                        aCell.Appearance = UltraGrid1.DisplayLayout.Appearances("EmptyCell")
                    Else
                        aCell.Appearance = UltraGrid1.DisplayLayout.Appearances("LeftAlign")
                    End If
                Case "ContractTypeDescr"
                    If aCell.Value.ToString = DBNull.Value.ToString OrElse aCell.Value.ToString = String.Empty Then
                        aCell.Appearance = UltraGrid1.DisplayLayout.Appearances("EmptyCell")
                    Else
                        aCell.Appearance = UltraGrid1.DisplayLayout.Appearances("RightAlign")
                    End If
                Case "Age"
                    If aCell.Value.ToString = DBNull.Value.ToString OrElse aCell.Value < 100 Then
                        aCell.Appearance = UltraGrid1.DisplayLayout.Appearances(IIf(CType(aCell.Value, Integer) = 0, "ZeroValue", "RightAlign"))
                    Else
                        aCell.Appearance = UltraGrid1.DisplayLayout.Appearances("MaxAge")
                    End If
                Case "DateOfBirth"
                    If aCell.Value.ToString = DBNull.Value.ToString OrElse aCell.Value.ToString = String.Empty Then
                        aCell.Appearance = UltraGrid1.DisplayLayout.Appearances("EmptyCell")
                    Else
                        aCell.Appearance = UltraGrid1.DisplayLayout.Appearances("LeftAlign")
                    End If
                Case "Subscribers"
                    aCell.Appearance = UltraGrid1.DisplayLayout.Appearances(IIf(CType(aCell.Value, Integer) = 0, "ZeroValue", "RightAlign"))
                Case "Sex"
                    aCell.Appearance = UltraGrid1.DisplayLayout.Appearances("CenterAlign")
            End Select
        Next

    End Sub
    ''' <summary>
    ''' This procedure will process the keystrokes on the UltraGrid.
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub UltraGrid1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles UltraGrid1.KeyDown

        If e.Modifiers = Keys.Control Then

            ''''''''''''''''''''''''
            ''  Copy/Paste Logic  ''
            ''''''''''''''''''''''''
            Select Case e.KeyCode

                Case Keys.C

                    '''''''''''
                    '' Copy  ''
                    '''''''''''
                    copieSelectedRowCount = UltraGrid1.Selected.Rows.Count

                Case Keys.V

                    UltraGrid1.DisplayLayout.Bands(0).Columns("DateOfBirth").CellActivation = Activation.AllowEdit

                    If copieSelectedRowCount > 0 Then

                        '' Override the add new behavior to add if it is Template related
                        If Not UltraGrid1.DisplayLayout.Override.AllowAddNew = AllowAddNew.Yes Then
                            UltraGrid1.DisplayLayout.Override.AllowAddNew = AllowAddNew.Yes
                        End If

                        ''''''''''''''''''''''''''''''''''''
                        '' Paste logic for selected rows  ''
                        ''''''''''''''''''''''''''''''''''''
                        If UltraGrid1.ActiveRow.IsAddRow Then
                            For i = 0 To copieSelectedRowCount - 2
                                UltraGrid1.DisplayLayout.Bands(0).AddNew()
                            Next
                        Else
                            Dim activeRowIndex As Int32 = UltraGrid1.ActiveRow.Index
                            Dim RestRowToAdd As Int32 = copieSelectedRowCount - (UltraGrid1.Rows.Count() - activeRowIndex)

                            If RestRowToAdd > 0 Then
                                For i = 0 To RestRowToAdd - 1
                                    UltraGrid1.DisplayLayout.Bands(0).AddNew()
                                Next
                            End If
                        End If

                        UltraGrid1.DisplayLayout.Override.AllowAddNew = AllowAddNew.TemplateOnBottom

                    End If

                    UltraGrid1.DisplayLayout.Bands(0).Columns("DateOfBirth").CellActivation = Activation.ActivateOnly

            End Select

        ElseIf e.Modifiers = Keys.Shift Then

            Select Case e.KeyCode
                Case Keys.Up
                    UltraGrid1.PerformAction(UltraGridAction.ExitEditMode, True, False)
                    UltraGrid1.PerformAction(UltraGridAction.AboveCell, True, False)
                    If UltraGrid1.ActiveRow IsNot Nothing AndAlso UltraGrid1.ActiveRow.Selected Then
                        'Row is selected:  do nothing!
                    Else
                        'Cell is selected: keystroke has been handled
                        e.Handled = True
                    End If
                Case Keys.Down
                    UltraGrid1.PerformAction(UltraGridAction.ExitEditMode, True, False)
                    UltraGrid1.PerformAction(UltraGridAction.BelowCell, True, False)
                    If UltraGrid1.ActiveRow IsNot Nothing AndAlso UltraGrid1.ActiveRow.Selected Then
                        'Row is selected:  do nothing
                    Else
                        'Cell is selected: keystroke has been handled
                        e.Handled = True
                    End If
            End Select

        Else

            '''''''''''''''''''''''''
            ''  Keystroke Handler  ''
            '''''''''''''''''''''''''

            Dim cell As UltraGridCell = UltraGrid1.ActiveCell

            If cell.Column.Key = "ContractTypeDescr" OrElse cell.Column.Key = "Product" Then
                'Ingore the arrow keys when we are on columns bound to dropdown comboboxes
                Exit Sub
            End If


            Select Case e.KeyCode
                Case Keys.Enter
                    UltraGrid1.PerformAction(UltraGridAction.ExitEditMode, False, False)
                    UltraGrid1.PerformAction(UltraGridAction.NextCellByTab, False, False)
                    e.Handled = True
                    UltraGrid1.PerformAction(UltraGridAction.EnterEditMode, False, False)
                Case Keys.Up
                    UltraGrid1.PerformAction(UltraGridAction.ExitEditMode, False, False)
                    UltraGrid1.PerformAction(UltraGridAction.AboveCell, False, False)
                    e.Handled = True
                    UltraGrid1.PerformAction(UltraGridAction.EnterEditMode, False, False)
                Case Keys.Down
                    UltraGrid1.PerformAction(UltraGridAction.ExitEditMode, False, False)
                    UltraGrid1.PerformAction(UltraGridAction.BelowCell, False, False)
                    e.Handled = True
                    UltraGrid1.PerformAction(UltraGridAction.EnterEditMode, False, False)
                Case Keys.PageDown
                    UltraGrid1.PerformAction(UltraGridAction.ExitEditMode, False, False)
                    UltraGrid1.PerformAction(UltraGridAction.PageDownCell, False, False)
                    e.Handled = True
                    UltraGrid1.PerformAction(UltraGridAction.EnterEditMode, False, False)
                Case Keys.PageUp
                    UltraGrid1.PerformAction(UltraGridAction.ExitEditMode, False, False)
                    UltraGrid1.PerformAction(UltraGridAction.PageUpCell, False, False)
                    e.Handled = True
                    UltraGrid1.PerformAction(UltraGridAction.EnterEditMode, False, False)

            End Select

        End If

    End Sub
    ''' <summary>
    ''' This procedure allows the user to enter Edit Mode.
    ''' </summary>
    ''' <param name="sender"></param>
    ''' <param name="e"></param>
    ''' <remarks></remarks>
    Private Sub UltraGrid1_DoubleClick(ByVal sender As Object, ByVal e As System.EventArgs) Handles UltraGrid1.DoubleClick
        UltraGrid1.PerformAction(UltraGridAction.EnterEditMode, False, False)
    End Sub
    Private Sub UltraGrid1_Enter(ByVal sender As Object, ByVal e As System.EventArgs) Handles UltraGrid1.Enter

        If IsFormInitialized = False OrElse IsProcessing Then Exit Sub

        ' If a user tabs into a grid, they’ll expect focus to be on the first editable cell so that 
        ' they can just start typing.  By default, when you tab into UltraGrid it gives the focus 
        ' to: nothing. As far as I can tell, it isn’t possible for users to start editing a grid 
        ' without using the mouse.  After much trial and error, I ended up adding the following code 
        ' to the grid’s Enter event:

        If UltraGrid1.ActiveCell Is Nothing Then
            If UltraGrid1.ActiveRow Is Nothing Then
                If UltraGrid1.Rows.Count = 0 Then
                    Return ' empty grid, so no way to give a cell focus
                End If
                UltraGrid1.ActiveRow = UltraGrid1.Rows(0)
            End If
            ' make the leftmost cell the active cell -- will find the first editable cell below
            UltraGrid1.ActiveCell = UltraGrid1.ActiveRow.Cells("Subgroup")
        End If

        Dim cell As UltraGridCell = UltraGrid1.ActiveCell

        If Not cell.CanEnterEditMode Then
            ' find the next editable cell
            UltraGrid1.PerformAction(UltraGridAction.NextCell)
        End If

        If Not UltraGrid1.ActiveCell Is Nothing Then
            While Not UltraGrid1.ActiveCell.CanEnterEditMode
                ' have we reached the end?
                UltraGrid1.PerformAction(UltraGridAction.NextCell)
                If UltraGrid1.ActiveCell Is Nothing Then
                    Return ' give up
                End If
                'If UltraGrid1.ActiveCell = cell Then
                '    Return ' we aren't going anywhere, give up

                'End If
                If (UltraGrid1.ActiveCell.Row.Index = 0) AndAlso (UltraGrid1.ActiveCell.Column.Key = "Subgroup") Then
                    Return ' looped around, so give up
                End If
                cell = UltraGrid1.ActiveCell

            End While
            If cell.CanEnterEditMode Then
                IsProcessing = True
                UltraGrid1.PerformAction(UltraGridAction.EnterEditMode)
                IsProcessing = False
            End If
            UltraGrid1.ActiveRowScrollRegion.ScrollCellIntoView(UltraGrid1.ActiveCell, UltraGrid1.DisplayLayout.ColScrollRegions(0))
        End If

    End Sub
#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        ' Label the Grid Caption
        UltraGrid1.Text = "Census Input"

        Try

            BuildDataTables()

            cboTierType.SelectedItem = "4T"
            FormatDataGridView()

            Dim dvContractTypes As New DataView(dtTypes)
            dvContractTypes.RowFilter = "Tier = '" & cboTierType.SelectedItem & "'"
            dvContractTypes.Sort = "TierNumber"

            With uddContractType
                .DataSource = dvContractTypes.ToTable
                .ValueMember = "ContractType"
                .DisplayMember = "TierNumber"
            End With

            With uddProducts
                .DataSource = dtProducts
                .ValueMember = "Product"
                .DisplayMember = "Product"
            End With

            With uddWorkStatus
                .DataSource = dtWorkStatus
                .ValueMember = "WorkStatus"
                .DisplayMember = "WorkStatus"
            End With

            '' Setup the DataSource  ''
            SetupDataSource()

        Catch ex As Exception

            MessageBox.Show("Error loading data:" & cc.NewLine & cc.NewLine & ex.Message)

        End Try

    End Sub

    Private Sub Form1_Shown(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Shown

        IsFormInitialized = True
        Me.ActiveControl = UltraGrid1

    End Sub
    Private Sub cboTierType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cboTierType.SelectedIndexChanged

        If IsFormInitialized = False Then Exit Sub

        Dim dvContractTypes As New DataView(dtTypes)
        dvContractTypes.RowFilter = "Tier = '" & cboTierType.SelectedItem & "'"
        dvContractTypes.Sort = "TierNumber"

        dgContractTypes.DataSource = dvContractTypes

        With uddContractType
            .DataSource = dvContractTypes.ToTable
        End With

    End Sub

    Private Sub tsbUpdate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbUpdate.Click

        Dim LastCaption As String = Me.Text

        Dim RowNumber = 0, TotalRows As Integer = 0

        Me.Text = "Searching for invalid rows..."
        Me.Cursor = Cursors.WaitCursor
        UltraGrid1.Enabled = False
        tsCensus.Enabled = False
        ToolStripProgressBar1.Value = 0

        TotalRows = UltraDataSource1.Rows.Count

        Dim rowItemsToRemove As New List(Of UltraDataRow)()
        Dim uRow As UltraDataRow

        Dim cellAge As Object = Nothing
        Dim cellZip As Object = Nothing
        Dim cellProduct As Object = Nothing

        Try

            ''''''''''''''''''''''''''''''''''''''''''''''''
            ''  Step #1:  Collect the rows to be removed  ''
            ''            into the ArrayList.             ''
            ''''''''''''''''''''''''''''''''''''''''''''''''
            For Each uRow In UltraDataSource1.Rows
                cellProduct = UltraDataSource1.Rows(uRow.Index).GetCellValue("Product")
                cellAge = UltraDataSource1.Rows(uRow.Index).GetCellValue("Age")
                cellZip = UltraDataSource1.Rows(uRow.Index).GetCellValue("ZipCode")
                Dim intValue As Integer
                If TypeOf cellAge Is System.DBNull OrElse (Int32.TryParse(TryCast(cellAge, String), intValue)) Then
                    rowItemsToRemove.Add(uRow)
                ElseIf TypeOf cellZip Is System.DBNull Then
                    rowItemsToRemove.Add(uRow)
                End If
                ToolStripProgressBar1.Value = CType((RowNumber / TotalRows) * 100, Integer)
                RowNumber += 1
            Next

            ToolStripProgressBar1.Value = 100
            Application.DoEvents()

            RowNumber = 0

            ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
            ''  Step #2:  Remove the rows from the UltraDataSource  ''
            ''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
            Me.Text = "Removing invalid rows..."
            For Each uRow In rowItemsToRemove
                UltraDataSource1.Rows.Remove(uRow, True)
                ToolStripProgressBar1.Value = CType((RowNumber / rowItemsToRemove.Count) * 100, Integer)
                RowNumber += 1
            Next

            ToolStripProgressBar1.Value = 100
            Application.DoEvents()

        Catch ex As Exception

            MessageBox.Show("Error updating your census:" & cc.NewLine & cc.NewLine & ex.Message, "ERNIE Census", MessageBoxButtons.OK, MessageBoxIcon.Error)
            Exit Sub

        Finally

            Me.Cursor = Cursors.Default
            Me.Text = LastCaption

            UltraGrid1.Enabled = True
            tsCensus.Enabled = True

            ToolStripProgressBar1.Value = 0
            UltraGrid1.Focus()

        End Try

        MessageBox.Show("Census has been updated", "ERNIE Census", MessageBoxButtons.OK, MessageBoxIcon.Information)

    End Sub

    Private Sub tsbClose_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tsbClose.Click
        Me.Close()
    End Sub

    Private Sub UltraGrid1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles UltraGrid1.KeyPress

    End Sub
End Class